/* Fo
 * fo-property-border.h: Common border property definitions
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-border.h,v 1.3 2003/03/21 14:41:25 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_BORDER_H__
#define __FO_PROPERTY_BORDER_H__

#include <libfo/fo-utils.h>
#include <fo-property.h>

typedef struct _FoPropertyBorder      FoPropertyBorder;
typedef struct _FoPropertyBorderClass FoPropertyBorderClass;

G_BEGIN_DECLS

/* border-width */
/* <border-width> | inherit */
typedef enum {
  FO_ENUM_BORDER_WIDTH_THIN,
  FO_ENUM_BORDER_WIDTH_MEDIUM,
  FO_ENUM_BORDER_WIDTH_THICK
} FoEnumBorderWidth;

GType fo_enum_border_width_get_type (void);
#define FO_TYPE_ENUM_BORDER_WIDTH fo_enum_border_width_get_type ()

/* border-style */
/* <border-style> | inherit */
typedef enum {
  FO_ENUM_BORDER_STYLE_NONE,
  FO_ENUM_BORDER_STYLE_HIDDEN,
  FO_ENUM_BORDER_STYLE_DOTTED,
  FO_ENUM_BORDER_STYLE_DASHED,
  FO_ENUM_BORDER_STYLE_SOLID,
  FO_ENUM_BORDER_STYLE_DOUBLE,
  FO_ENUM_BORDER_STYLE_GROOVE,
  FO_ENUM_BORDER_STYLE_RIDGE,
  FO_ENUM_BORDER_STYLE_INSET,
  FO_ENUM_BORDER_STYLE_OUTSET
} FoEnumBorderStyle;

GType fo_enum_border_style_get_type (void);
#define FO_TYPE_ENUM_BORDER_STYLE fo_enum_border_style_get_type ()

#define FO_TYPE_PROPERTY_BORDER              (fo_property_border_get_type ())
#define FO_PROPERTY_BORDER(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_BORDER, FoPropertyBorder))
#define FO_PROPERTY_BORDER_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_BORDER, FoPropertyBorderClass))
#define FO_IS_PROPERTY_BORDER(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_BORDER))
#define FO_IS_PROPERTY_BORDER_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_BORDER))
#define FO_PROPERTY_BORDER_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_BORDER, FoPropertyBorderClass))

GType       fo_property_border_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_border_new           (void);
void        fo_property_border_resolve (FoContext *current_context,
					FoContext *parent_context);

G_END_DECLS

#endif /* !__FO_PROPERTY_BORDER_H__ */
